local mod = RW:Boss("Thorim", "Ulduar", "Ulduar")
local L

---------------------------
-- Variables
local tLightningChargeCast, tLightningChargeCD, wLightningChargem, mLightningChargeStack
local tHardmode, mPhase2
local tUnbalancingStrikeDur, tUnbalancingStrikeCD
local tBlizzardDur, tBlizzardCast, wBlizzard

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Thorim"
		
		L.YellPull = "Interlopers! You mortals who dare to interfere with my sport will pay... Wait--you..."
		L.YellPhase2 = "Impertinent whelps! You dare challenge me atop my pedestal! I will crush you myself!"
		L.YellDeath = "Stay your arms! I yield!"
		L.Ding_msg = "Ding %d!"
		L.Ding_opt = "Ding message"
		L.Phase2_msg = "Phase 2"
		L.Phase2_opt = "Phase 2 message"
	end

	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(L.YellPull, 32865)
	self:SetWin(L.YellDeath, 32865)

	tBerserk = self:BerserkTimer(369)

	tLightningChargeCast, tLightningChargeCD, wLightningCharge, mLightningChargeStack = self:CastTimer(5, 62466), self:CDTimer(11, 62466), self:RunawayWarning(62466), self:CustomMessage({L.Ding_msg, L.Ding_opt}, 24312, nil, false)
	tHardmode, mPhase2 = self:DurTimer(175, 62042), self:CustomMessage({L.Phase2_msg, L.Phase2_opt}, 63131, nil, false)
	tUnbalancingStrikeDur, tUnbalancingStrikeCD = self:DurTimer(15, 62130), self:CDTimer(23, 62130)
	tBlizzardDur, tBlizzardCast, wBlizzard = self:DurTimer(10, 62576), self:CastTimer(62576), self:CastWarning(62576)
	
end

---------------------------
-- Locals


---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("LightningCharge", 62279, 62466)
	self:TrackYell("Phase2", L.YellPhase2)
	self:Track("UnbalancingStrike", 62130)
	self:Track("Blizzard", 62577, 62603, 62576, 62602)
	self:TrackYell("Win", L.YellDeath)
	
	mod:SendMessage("RW_ShowRangeCheck", false, 10)
	
	tBerserk:Start()
	tHardmode:Start()
end

function mod:LightningCharge(event, args)
	if event == "SPELL_CAST_SUCCESS" then
	 	tLightningChargeCast:Start()
		tLightningChargeCD:Schedule(5)
		wLightningCharge:Show()
	end
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then -- not sure if "if (event or event) and option then" parenthesis work here or not
		if mod.db.profile.Ding_opt == true then
			mLightningChargeStack:Show()
			PlaySoundFile("Sound\\Interface\\LevelUp.wav")
		end
	end
end

function mod:Phase2(event, msg, name)
	if msg == L.YellPhase2 then
		tBerserk:Cancel()
		tHardmode:Cancel()
		mod:SendMessage("RW_ShowRangeCheck", true, 10)
	end
end

function mod:UnbalancingStrike(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tUnbalancingStrikeCD:Start()
	end
	if event == "SPELL_AURA_APPLIED" then
		tUnbalancingStrikeDur:Start()
	end
end	

function mod:Blizzard(event, args)
	if event == "SPELL_CAST_START" then
		tBlizzardCast:Start()
		wBlizzard:Show()
	end
	if event == "SPELL_CAST_SUCCESS" then
		tBlizzardDur:Start()
	end
	if event == "SPELL_AURA_APPLIED" then
		wBlizzard:Show()
	end
end	