local mod = RW:Boss("Yogg-Saron", "Ulduar", "Ulduar")
local L

---------------------------
-- Variables
local tBerserk
local tSpeedKill
-- Phase 1
local mPhase1
local wSarasFervor, iSarasFervor
local mGuardianSpawn
-- Phase 2
local mPhase2
local tMaladyCast, wMalady, wMaladyLink, iMalady
local wSqueeze, iSqueeze
local tNextPortals, wPortalsSoon, tInduceMadness, wInduceMadness
local wBrainLink, iBrainLink
-- Phase 3
local mPhase3
local tDeafeningRoarCast, tDeafeningRoarCD
local tLunaticGazeDur, tLunaticGazeCD
local tShadowBeaconCD, tShadowBeaconDur, wShadowBeacon
local tEmpoweringShadowsDur

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Yogg-Saron"
		
		L.YellPull = "Sara yells: The time to strike at the head of the beast will soon be upon us! Focus your anger and hatred on his minions!"
		L.YellDeath = "Your fate is sealed. The end of days is finally upon you and ALL who inhabit this miserable little seedling. Uulwi ifis halahs gag erh'ongg w'ssh."
		L.YellPhase2 = "Sara yells: I am the lucid dream."
		L.YellPhase3 = "Look upon the true face of death and know that your end comes soon!"
		L.Phase1_msg = "Phase 1"
		L.Phase1_opt = "Phase 1 message"
		L.Phase2_msg = "Phase 2"
		L.Phase2_opt = "Phase 2 message"
		L.Phase3_msg = "Phase 3"
		L.Phase3_opt = "Phase 3 message"
		L.Madness_msg = "Get out!"
		L.Madness_opt = "Induce Madness 5sec warning"
		L.Portals_msg = "Portals soon!"
		L.Portals_opt = "Portals soon warning"

	end

	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(L.YellPull, 33288)
	self:SetWin(L.YellDeath, 33288)
	
	tBerserk = self:BerserkTimer(900)
--	tSpeedKill = self:AchievementTimer(420)
	
-- Phase 1
	mPhase1 = self:CustomMessage({L.Phase1_msg, L.Phase1_opt}, 63130, nil, true)
	wSarasFervor, iSarasFervor = self:CastWarning(63138), self:Icon("SKULL", 63138, false, 15, "CROSS", "SQUARE")
	mGuardianSpawn = self:CastMessage(62979)
-- Phase 2
	mPhase2 = self:CustomMessage({L.Phase2_msg, L.Phase2_opt}, 63131, nil, true)
	tMaladyCast, wMalady, iMalady = self:CastTimer(63830), self:CastWarning(63830), self:Icon("SKULL", 63830, false, 4)
	wSqueeze, iSqueeze = self:CastWarning(64126), self:Icon("CROSS", 64126, false, 20, "CIRCLE")
	tNextPortals, wPortalsSoon, tInduceMadness, wInduceMadness = self:DurTimer(27, 49361), self:CustomWarning({L.Portals_msg, L.Portals_opt}, 49361, nil, true),   self:CastTimer(64059), self:CustomWarning({L.Madness_msg, L.Madness_opt}, 64059, nil, true)
	wBrainLink, iBrainLink = self:CastWarning(63802), self:Icon("DIAMOND", 63802, false, 30, "TRIANGLE", "MOON", "SQUARE")
-- Phase 3
	mPhase3 = self:CustomMessage({L.Phase3_msg, L.Phase3_opt}, 63132, nil, true)
	tDeafeningRoarCast, tDeafeningRoarCD = self:CastTimer(64189), self:CDTimer(57.7, 64189)
	tLunaticGazeDur, tLunaticGazeCD = self:DurTimer(4, 64163), self:CDTimer(5, 64163)
	tShadowBeaconCD, tShadowBeaconDur, wShadowBeacon = self:CDTimer(35, 64465), self:DurTimer(10, 64465), self:CastWarning(64465)
	tEmpoweringShadowsDur = self:DurTimer(20, 64468)
end

---------------------------
-- Locals
local guardianCount
local empShadows
local sBeacon

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("SarasFervor", 63138)
	self:Track("GuardianSpawn", 62979)
	
	self:TrackYell("Phase2", L.YellPhase2)
	self:Track("Malady", 63830, 63831)
	self:Track("Squeeze", 64125, 64126)
	self:Track("InduceMadness", 64059)
	self:Track("BrainLink", 63802)
	
	self:TrackYell("Phase3", L.YellPhase3)
	self:Track("DeafeningRoar", 64189)
	self:Track("LunaticGaze", 64163)
	self:Track("ShadowBeacon", 64465)
	self:Track("EmpoweringShadows", 64468, 64486)
	
	guardianCount = 0
	empShadows = false
	tBerserk:Start()
--	tSpeedKill:Start()
	mPhase1:Show()	
	self:SendMessage("RW_AddHealthFrame", 33134)
end

----------------- Phase 1
function mod:SarasFervor(event, args)
	if event == "SPELL_AURA_APPLIED" then
	 	iSarasFervor:Show(args.dName)
		if args:IsPlayer() then
			wSarasFervor:Show()
		end
	end
end

function mod:GuardianSpawn(event, args)
	if event == "SPELL_SUMMON" then
		guardianCount = guardianCount +1
		mGuardianSpawn:Show(guardianCount)
	end
end

----------------- Phase 2
function mod:Phase2(event, msg, name)
	if msg == L.YellPhase2 then
		self:SendMessage("RW_RemoveAllHealthFrames")
		mPhase2:Show()
		tNextPortals:Start(60)
		wPortalsSoon:Schedule(50)
	end
end	

function mod:Malady(event, args)
	if event == "SPELL_CAST_START" then
		tMaladyCast:Start()
		wMalady:Show()
		iMalady:Show(args.dName)
	end
end

function mod:Squeeze(event, args)
	if event == "SPELL_AURA_APPLIED" then
		wSqueeze:Show(args.dName)
		iSqueeze:Show(args.dName)
	end
	if event == "SPELL_AURA_REMOVED" then
		iSqueeze:Hide(args.dName)
	end
end

function mod:InduceMadness(event, args)
	if event == "SPELL_CAST_START" then
		tInduceMadness:Start()
		wInduceMadness:Schedule(55)
		tNextPortals:Schedule(60)
		wPortalsSoon:Schedule(77)
	end
end

function mod:BrainLink(event, args)
	if event == "SPELL_AURA_APPLIED" then
		iBrainLink:Show(args.dName)
		if args:IsPlayer() then
			wBrainLink:Show()
		end
	end
end

----------------- Phase 3
function mod:Phase3(event, msg, name)
	if msg == L.YellPhase3 then
		mPhase3:Show()
	end
end	

function mod:DeafeningRoar(event, args)
	if event == "SPELL_CAST_START" then
		tDeafeningRoarCast:Start()
	end
	if event == "SPELL_CAST_SUCCESS" then
		tDeafeningRoarCD:Start()
	end
end

function mod:LunaticGaze(event, args)
	if event == "SPELL_CAST_START" then
		tLunaticGazeDur:Start()
		tLunaticGazeCD:Schedule(4)
	end
end

function mod:ShadowBeacon(event, args)
	if event == "SPELL_AURA_APPLIED" and sBeacon == false then
		tShadowBeaconDur:Start() 
		wShadowBeacon:Show()
		sBeacon = true
		self:Schedule("BeaconCheck", 0.2, sBeacon)
	end
	if event == "SPELL_AURA_REMOVED" then
		tShadowBeaconCD:Start()
	end
end

local function BeaconCheck()
	sBeacon = false
end

function mod:EmpoweringShadows(event, args)
	if event == "SPELL_AURA_APPLIED" and empShadows == false then
		tEmpoweringShadowsDur:Start()
	end
	empShadows = true
	self:Schedule("EmpoweringCheck", 0.2, empShadows)
end

local function EmpoweringCheck()
	empShadows = false
end